Index: uspace/drv/nic/e1k/e1k.c
===================================================================
--- uspace/drv/nic/e1k/e1k.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/nic/e1k/e1k.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -179,22 +179,22 @@
 FIBRIL_MUTEX_INITIALIZE(irq_reg_mutex);
 
-static errno_t e1000_get_address(e1000_t *, nic_address_t *);
+static int e1000_get_address(e1000_t *, nic_address_t *);
 static void e1000_eeprom_get_address(e1000_t *, nic_address_t *);
-static errno_t e1000_set_addr(ddf_fun_t *, const nic_address_t *);
-
-static errno_t e1000_defective_get_mode(ddf_fun_t *, uint32_t *);
-static errno_t e1000_defective_set_mode(ddf_fun_t *, uint32_t);
-
-static errno_t e1000_get_cable_state(ddf_fun_t *, nic_cable_state_t *);
-static errno_t e1000_get_device_info(ddf_fun_t *, nic_device_info_t *);
-static errno_t e1000_get_operation_mode(ddf_fun_t *, int *,
+static int e1000_set_addr(ddf_fun_t *, const nic_address_t *);
+
+static int e1000_defective_get_mode(ddf_fun_t *, uint32_t *);
+static int e1000_defective_set_mode(ddf_fun_t *, uint32_t);
+
+static int e1000_get_cable_state(ddf_fun_t *, nic_cable_state_t *);
+static int e1000_get_device_info(ddf_fun_t *, nic_device_info_t *);
+static int e1000_get_operation_mode(ddf_fun_t *, int *,
     nic_channel_mode_t *, nic_role_t *);
-static errno_t e1000_set_operation_mode(ddf_fun_t *, int,
+static int e1000_set_operation_mode(ddf_fun_t *, int,
     nic_channel_mode_t, nic_role_t);
-static errno_t e1000_autoneg_enable(ddf_fun_t *, uint32_t);
-static errno_t e1000_autoneg_disable(ddf_fun_t *);
-static errno_t e1000_autoneg_restart(ddf_fun_t *);
-
-static errno_t e1000_vlan_set_tag(ddf_fun_t *, uint16_t, bool, bool);
+static int e1000_autoneg_enable(ddf_fun_t *, uint32_t);
+static int e1000_autoneg_disable(ddf_fun_t *);
+static int e1000_autoneg_restart(ddf_fun_t *);
+
+static int e1000_vlan_set_tag(ddf_fun_t *, uint16_t, bool, bool);
 
 /** Network interface options for E1000 card driver */
@@ -219,5 +219,5 @@
 static ddf_dev_ops_t e1000_dev_ops;
 
-static errno_t e1000_dev_add(ddf_dev_t *);
+static int e1000_dev_add(ddf_dev_t *);
 
 /** Basic driver operations for E1000 driver */
@@ -233,6 +233,6 @@
 
 /* The default implementation callbacks */
-static errno_t e1000_on_activating(nic_t *);
-static errno_t e1000_on_stopping(nic_t *);
+static int e1000_on_activating(nic_t *);
+static int e1000_on_stopping(nic_t *);
 static void e1000_send_frame(nic_t *, void *, size_t);
 
@@ -288,5 +288,5 @@
  *
  */
-static errno_t e1000_get_device_info(ddf_fun_t *dev, nic_device_info_t *info)
+static int e1000_get_device_info(ddf_fun_t *dev, nic_device_info_t *info)
 {
 	assert(dev);
@@ -316,5 +316,5 @@
  *
  */
-static errno_t e1000_get_cable_state(ddf_fun_t *fun, nic_cable_state_t *state)
+static int e1000_get_cable_state(ddf_fun_t *fun, nic_cable_state_t *state)
 {
 	e1000_t *e1000 = DRIVER_DATA_FUN(fun);
@@ -335,5 +335,5 @@
  *
  */
-static errno_t e1000_get_operation_mode(ddf_fun_t *fun, int *speed,
+static int e1000_get_operation_mode(ddf_fun_t *fun, int *speed,
     nic_channel_mode_t *duplex, nic_role_t *role)
 {
@@ -386,5 +386,5 @@
  *
  */
-static errno_t e1000_set_operation_mode(ddf_fun_t *fun, int speed,
+static int e1000_set_operation_mode(ddf_fun_t *fun, int speed,
     nic_channel_mode_t duplex, nic_role_t role)
 {
@@ -434,5 +434,5 @@
  *
  */
-static errno_t e1000_autoneg_enable(ddf_fun_t *fun, uint32_t advertisement)
+static int e1000_autoneg_enable(ddf_fun_t *fun, uint32_t advertisement)
 {
 	e1000_t *e1000 = DRIVER_DATA_FUN(fun);
@@ -462,5 +462,5 @@
  *
  */
-static errno_t e1000_autoneg_disable(ddf_fun_t *fun)
+static int e1000_autoneg_disable(ddf_fun_t *fun)
 {
 	e1000_t *e1000 = DRIVER_DATA_FUN(fun);
@@ -490,5 +490,5 @@
  *
  */
-static errno_t e1000_autoneg_restart(ddf_fun_t *dev)
+static int e1000_autoneg_restart(ddf_fun_t *dev)
 {
 	return e1000_autoneg_enable(dev, 0);
@@ -501,5 +501,5 @@
  *
  */
-static errno_t e1000_defective_get_mode(ddf_fun_t *fun, uint32_t *mode)
+static int e1000_defective_get_mode(ddf_fun_t *fun, uint32_t *mode)
 {
 	e1000_t *e1000 = DRIVER_DATA_FUN(fun);
@@ -522,8 +522,8 @@
  *
  */
-static errno_t e1000_defective_set_mode(ddf_fun_t *fun, uint32_t mode)
+static int e1000_defective_set_mode(ddf_fun_t *fun, uint32_t mode)
 {
 	e1000_t *e1000 = DRIVER_DATA_FUN(fun);
-	errno_t rc = EOK;
+	int rc = EOK;
 	
 	fibril_mutex_lock(&e1000->rx_lock);
@@ -827,9 +827,9 @@
  *
  */
-static errno_t e1000_on_multicast_mode_change(nic_t *nic, nic_multicast_mode_t mode,
+static int e1000_on_multicast_mode_change(nic_t *nic, nic_multicast_mode_t mode,
     const nic_address_t *addr, size_t addr_cnt)
 {
 	e1000_t *e1000 = DRIVER_DATA_NIC(nic);
-	errno_t rc = EOK;
+	int rc = EOK;
 	
 	fibril_mutex_lock(&e1000->rx_lock);
@@ -881,9 +881,9 @@
  *
  */
-static errno_t e1000_on_unicast_mode_change(nic_t *nic, nic_unicast_mode_t mode,
+static int e1000_on_unicast_mode_change(nic_t *nic, nic_unicast_mode_t mode,
     const nic_address_t *addr, size_t addr_cnt)
 {
 	e1000_t *e1000 = DRIVER_DATA_NIC(nic);
-	errno_t rc = EOK;
+	int rc = EOK;
 	
 	fibril_mutex_lock(&e1000->rx_lock);
@@ -937,8 +937,8 @@
  *
  */
-static errno_t e1000_on_broadcast_mode_change(nic_t *nic, nic_broadcast_mode_t mode)
+static int e1000_on_broadcast_mode_change(nic_t *nic, nic_broadcast_mode_t mode)
 {
 	e1000_t *e1000 = DRIVER_DATA_NIC(nic);
-	errno_t rc = EOK;
+	int rc = EOK;
 	
 	fibril_mutex_lock(&e1000->rx_lock);
@@ -1048,5 +1048,5 @@
  *
  */
-static errno_t e1000_vlan_set_tag(ddf_fun_t *fun, uint16_t tag, bool add,
+static int e1000_vlan_set_tag(ddf_fun_t *fun, uint16_t tag, bool add,
     bool strip)
 {
@@ -1259,10 +1259,9 @@
  * @param nic Driver data
  *
- * @param[out] handle  IRQ capability handle if the handler was registered
- *
- * @return An error code otherwise
- *
- */
-inline static errno_t e1000_register_int_handler(nic_t *nic, cap_handle_t *handle)
+ * @return IRQ capability handle if the handler was registered
+ * @return Negative error code otherwise
+ *
+ */
+inline static int e1000_register_int_handler(nic_t *nic)
 {
 	e1000_t *e1000 = DRIVER_DATA_NIC(nic);
@@ -1275,9 +1274,9 @@
 	e1000_irq_code.cmds[2].addr = e1000->reg_base_phys + E1000_IMC;
 	
-	errno_t rc = register_interrupt_handler(nic_get_ddf_dev(nic), e1000->irq,
-	    e1000_interrupt_handler, &e1000_irq_code, handle);
+	int cap = register_interrupt_handler(nic_get_ddf_dev(nic), e1000->irq,
+	    e1000_interrupt_handler, &e1000_irq_code);
 	
 	fibril_mutex_unlock(&irq_reg_mutex);
-	return rc;
+	return cap;
 }
 
@@ -1319,5 +1318,5 @@
  *
  */
-static errno_t e1000_poll_mode_change(nic_t *nic, nic_poll_mode_t mode,
+static int e1000_poll_mode_change(nic_t *nic, nic_poll_mode_t mode,
     const struct timeval *period)
 {
@@ -1370,8 +1369,8 @@
  *
  * @return EOK if succeed
- * @return An error code otherwise
- *
- */
-static errno_t e1000_initialize_rx_structure(nic_t *nic)
+ * @return Negative error code otherwise
+ *
+ */
+static int e1000_initialize_rx_structure(nic_t *nic)
 {
 	e1000_t *e1000 = DRIVER_DATA_NIC(nic);
@@ -1379,5 +1378,5 @@
 	
 	e1000->rx_ring_virt = AS_AREA_ANY;
-	errno_t rc = dmamem_map_anonymous(
+	int rc = dmamem_map_anonymous(
 	    E1000_RX_FRAME_COUNT * sizeof(e1000_rx_descriptor_t),
 	    DMAMEM_4GiB, AS_AREA_READ | AS_AREA_WRITE, 0,
@@ -1524,5 +1523,5 @@
  *
  * @return EOK if succeed
- * @return An error code otherwise
+ * @return Negative error code otherwise
  *
  */
@@ -1567,5 +1566,5 @@
  *
  */
-static errno_t e1000_initialize_tx_structure(e1000_t *e1000)
+static int e1000_initialize_tx_structure(e1000_t *e1000)
 {
 	size_t i;
@@ -1579,5 +1578,5 @@
 	e1000->tx_frame_virt = NULL;
 	
-	errno_t rc = dmamem_map_anonymous(
+	int rc = dmamem_map_anonymous(
 	    E1000_TX_FRAME_COUNT * sizeof(e1000_tx_descriptor_t),
 	    DMAMEM_4GiB, AS_AREA_READ | AS_AREA_WRITE, 0,
@@ -1718,5 +1717,5 @@
  *
  */
-static errno_t e1000_reset(nic_t *nic)
+static int e1000_reset(nic_t *nic)
 {
 	e1000_t *e1000 = DRIVER_DATA_NIC(nic);
@@ -1749,5 +1748,5 @@
  *
  */
-static errno_t e1000_on_activating(nic_t *nic)
+static int e1000_on_activating(nic_t *nic)
 {
 	assert(nic);
@@ -1761,5 +1760,5 @@
 	e1000_enable_interrupts(e1000);
 	
-	errno_t rc = hw_res_enable_interrupt(e1000->parent_sess, e1000->irq);
+	int rc = hw_res_enable_interrupt(e1000->parent_sess, e1000->irq);
 	if (rc != EOK) {
 		e1000_disable_interrupts(e1000);
@@ -1795,5 +1794,5 @@
  *
  */
-static errno_t e1000_on_down_unlocked(nic_t *nic)
+static int e1000_on_down_unlocked(nic_t *nic)
 {
 	e1000_t *e1000 = DRIVER_DATA_NIC(nic);
@@ -1826,5 +1825,5 @@
  *
  */
-static errno_t e1000_on_down(nic_t *nic)
+static int e1000_on_down(nic_t *nic)
 {
 	e1000_t *e1000 = DRIVER_DATA_NIC(nic);
@@ -1834,5 +1833,5 @@
 	fibril_mutex_lock(&e1000->ctrl_lock);
 	
-	errno_t rc = e1000_on_down_unlocked(nic);
+	int rc = e1000_on_down_unlocked(nic);
 	
 	fibril_mutex_unlock(&e1000->ctrl_lock);
@@ -1851,5 +1850,5 @@
  *
  */
-static errno_t e1000_on_stopping(nic_t *nic)
+static int e1000_on_stopping(nic_t *nic)
 {
 	e1000_t *e1000 = DRIVER_DATA_NIC(nic);
@@ -1859,5 +1858,5 @@
 	fibril_mutex_lock(&e1000->ctrl_lock);
 	
-	errno_t rc = e1000_on_down_unlocked(nic);
+	int rc = e1000_on_down_unlocked(nic);
 	if (rc == EOK)
 		rc = e1000_reset(nic);
@@ -1940,8 +1939,8 @@
  *
  * @return EOK if succeed
- * @return An error code otherwise
- *
- */
-static errno_t e1000_fill_resource_info(ddf_dev_t *dev,
+ * @return Negative error code otherwise
+ *
+ */
+static int e1000_fill_resource_info(ddf_dev_t *dev,
     const hw_res_list_parsed_t *hw_resources)
 {
@@ -1965,8 +1964,8 @@
  *
  * @return EOK if succeed
- * @return An error code otherwise
- *
- */
-static errno_t e1000_get_resource_info(ddf_dev_t *dev)
+ * @return Negative error code otherwise
+ *
+ */
+static int e1000_get_resource_info(ddf_dev_t *dev)
 {
 	assert(dev != NULL);
@@ -1977,5 +1976,5 @@
 	
 	/* Get hw resources form parent driver */
-	errno_t rc = nic_get_resources(NIC_DATA_DEV(dev), &hw_res_parsed);
+	int rc = nic_get_resources(NIC_DATA_DEV(dev), &hw_res_parsed);
 	if (rc != EOK)
 		return rc;
@@ -1993,8 +1992,8 @@
  *
  * @return EOK if succeed
- * @return An error code otherwise
- *
- */
-static errno_t e1000_device_initialize(ddf_dev_t *dev)
+ * @return Negative error code otherwise
+ *
+ */
+static int e1000_device_initialize(ddf_dev_t *dev)
 {
 	/* Allocate driver data for the device. */
@@ -2012,5 +2011,5 @@
 	
 	/* Obtain and fill hardware resources info */
-	errno_t rc = e1000_get_resource_info(dev);
+	int rc = e1000_get_resource_info(dev);
 	if (rc != EOK) {
 		ddf_msg(LVL_ERROR, "Cannot obtain hardware resources");
@@ -2107,12 +2106,12 @@
  *
  * @return EOK if successed
- * @return An error code otherwise
- *
- */
-static errno_t e1000_pio_enable(ddf_dev_t *dev)
+ * @return Negative error code otherwise
+ *
+ */
+static int e1000_pio_enable(ddf_dev_t *dev)
 {
 	e1000_t *e1000 = DRIVER_DATA_DEV(dev);
 	
-	errno_t rc = pio_enable(e1000->reg_base_phys, 8 * PAGE_SIZE,
+	int rc = pio_enable(e1000->reg_base_phys, 8 * PAGE_SIZE,
 	    &e1000->reg_base_virt);
 	if (rc != EOK)
@@ -2127,10 +2126,10 @@
  *
  */
-errno_t e1000_dev_add(ddf_dev_t *dev)
+int e1000_dev_add(ddf_dev_t *dev)
 {
 	ddf_fun_t *fun;
 	
 	/* Initialize device structure for E1000 */
-	errno_t rc = e1000_device_initialize(dev);
+	int rc = e1000_device_initialize(dev);
 	if (rc != EOK)
 		return rc;
@@ -2165,7 +2164,7 @@
 	ddf_fun_set_ops(fun, &e1000_dev_ops);
 	
-	int irq_cap;
-	rc = e1000_register_int_handler(nic, &irq_cap);
-	if (rc != EOK) {
+	int irq_cap = e1000_register_int_handler(nic);
+	if (irq_cap < 0) {
+		rc = irq_cap;
 		goto err_fun_create;
 	}
@@ -2255,8 +2254,8 @@
  *
  * @return EOK if succeed
- * @return An error code otherwise
- *
- */
-static errno_t e1000_get_address(e1000_t *e1000, nic_address_t *address)
+ * @return Negative error code otherwise
+ *
+ */
+static int e1000_get_address(e1000_t *e1000, nic_address_t *address)
 {
 	fibril_mutex_lock(&e1000->rx_lock);
@@ -2289,7 +2288,7 @@
  *
  * @return EOK if succeed
- * @return An error code otherwise
- */
-static errno_t e1000_set_addr(ddf_fun_t *fun, const nic_address_t *addr)
+ * @return Negative error code otherwise
+ */
+static int e1000_set_addr(ddf_fun_t *fun, const nic_address_t *addr)
 {
 	nic_t *nic = NIC_DATA_FUN(fun);
@@ -2299,5 +2298,5 @@
 	fibril_mutex_lock(&e1000->tx_lock);
 	
-	errno_t rc = nic_report_address(nic, addr);
+	int rc = nic_report_address(nic, addr);
 	if (rc == EOK)
 		e1000_write_receive_address(e1000, 0, addr, false);
Index: uspace/drv/nic/ne2k/dp8390.c
===================================================================
--- uspace/drv/nic/ne2k/dp8390.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/nic/ne2k/dp8390.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -194,5 +194,5 @@
  *
  */
-errno_t ne2k_probe(ne2k_t *ne2k)
+int ne2k_probe(ne2k_t *ne2k)
 {
 	unsigned int i;
@@ -250,5 +250,5 @@
  *
  */
-errno_t ne2k_up(ne2k_t *ne2k)
+int ne2k_up(ne2k_t *ne2k)
 {
 	if (!ne2k->probed)
Index: uspace/drv/nic/ne2k/dp8390.h
===================================================================
--- uspace/drv/nic/ne2k/dp8390.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/nic/ne2k/dp8390.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -265,6 +265,6 @@
 } ne2k_t;
 
-extern errno_t ne2k_probe(ne2k_t *);
-extern errno_t ne2k_up(ne2k_t *);
+extern int ne2k_probe(ne2k_t *);
+extern int ne2k_up(ne2k_t *);
 extern void ne2k_down(ne2k_t *);
 extern void ne2k_send(nic_t *, void *, size_t);
Index: uspace/drv/nic/ne2k/ne2k.c
===================================================================
--- uspace/drv/nic/ne2k/ne2k.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/nic/ne2k/ne2k.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -124,5 +124,5 @@
 static void ne2k_interrupt_handler(ipc_call_t *, ddf_dev_t *);
 
-static errno_t ne2k_register_interrupt(nic_t *nic_data, cap_handle_t *handle)
+static int ne2k_register_interrupt(nic_t *nic_data)
 {
 	ne2k_t *ne2k = (ne2k_t *) nic_get_specific(nic_data);
@@ -160,6 +160,7 @@
 	}
 
-	return register_interrupt_handler(nic_get_ddf_dev(nic_data),
-		ne2k->irq, ne2k_interrupt_handler, &ne2k->code, handle);
+	int irq_cap = register_interrupt_handler(nic_get_ddf_dev(nic_data),
+		ne2k->irq, ne2k_interrupt_handler, &ne2k->code);
+	return irq_cap;
 }
 
@@ -178,5 +179,5 @@
 }
 
-static errno_t ne2k_dev_init(nic_t *nic_data)
+static int ne2k_dev_init(nic_t *nic_data)
 {
 	/* Get HW resources */
@@ -184,5 +185,5 @@
 	hw_res_list_parsed_init(&hw_res_parsed);
 	
-	errno_t rc = nic_get_resources(nic_data, &hw_res_parsed);
+	int rc = nic_get_resources(nic_data, &hw_res_parsed);
 	
 	if (rc != EOK)
@@ -227,5 +228,6 @@
 	ne2k->probed = true;
 	
-	if (ne2k_register_interrupt(nic_data, NULL) != EOK)
+	int irq_cap = ne2k_register_interrupt(nic_data);
+	if (irq_cap < 0)
 		return EINVAL;
 	
@@ -243,10 +245,10 @@
 }
 
-static errno_t ne2k_on_activating(nic_t *nic_data)
+static int ne2k_on_activating(nic_t *nic_data)
 {
 	ne2k_t *ne2k = (ne2k_t *) nic_get_specific(nic_data);
 
 	if (!ne2k->up) {
-		errno_t rc = ne2k_up(ne2k);
+		int rc = ne2k_up(ne2k);
 		if (rc != EOK)
 			return rc;
@@ -261,5 +263,5 @@
 }
 
-static errno_t ne2k_on_stopping(nic_t *nic_data)
+static int ne2k_on_stopping(nic_t *nic_data)
 {
 	ne2k_t *ne2k = (ne2k_t *) nic_get_specific(nic_data);
@@ -271,8 +273,8 @@
 }
 
-static errno_t ne2k_set_address(ddf_fun_t *fun, const nic_address_t *address)
+static int ne2k_set_address(ddf_fun_t *fun, const nic_address_t *address)
 {
 	nic_t *nic_data = DRIVER_DATA(ddf_fun_get_dev(fun));
-	errno_t rc = nic_report_address(nic_data, address);
+	int rc = nic_report_address(nic_data, address);
 	if (rc != EOK) {
 		return EINVAL;
@@ -286,5 +288,5 @@
 }
 
-static errno_t ne2k_on_unicast_mode_change(nic_t *nic_data,
+static int ne2k_on_unicast_mode_change(nic_t *nic_data,
 	nic_unicast_mode_t new_mode,
 	const nic_address_t *address_list, size_t address_count)
@@ -313,5 +315,5 @@
 }
 
-static errno_t ne2k_on_multicast_mode_change(nic_t *nic_data,
+static int ne2k_on_multicast_mode_change(nic_t *nic_data,
 	nic_multicast_mode_t new_mode,
 	const nic_address_t *address_list, size_t address_count)
@@ -339,5 +341,5 @@
 }
 
-static errno_t ne2k_on_broadcast_mode_change(nic_t *nic_data,
+static int ne2k_on_broadcast_mode_change(nic_t *nic_data,
 	nic_broadcast_mode_t new_mode)
 {
@@ -355,5 +357,5 @@
 }
 
-static errno_t ne2k_dev_add(ddf_dev_t *dev)
+static int ne2k_dev_add(ddf_dev_t *dev)
 {
 	ddf_fun_t *fun;
@@ -387,5 +389,5 @@
 	}
 	
-	errno_t rc = ne2k_dev_init(nic_data);
+	int rc = ne2k_dev_init(nic_data);
 	if (rc != EOK) {
 		ne2k_dev_cleanup(dev);
Index: uspace/drv/nic/rtl8139/driver.c
===================================================================
--- uspace/drv/nic/rtl8139/driver.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/nic/rtl8139/driver.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -217,5 +217,5 @@
  *  @param address  The place to store the address
  *
- *  @return EOK if succeed, error code otherwise
+ *  @return EOK if succeed, negative error code otherwise
  */
 inline static void rtl8139_hw_get_addr(rtl8139_t *rtl8139,
@@ -280,32 +280,32 @@
 }
 
-static errno_t rtl8139_set_addr(ddf_fun_t *fun, const nic_address_t *);
-static errno_t rtl8139_get_device_info(ddf_fun_t *fun, nic_device_info_t *info);
-static errno_t rtl8139_get_cable_state(ddf_fun_t *fun, nic_cable_state_t *state);
-static errno_t rtl8139_get_operation_mode(ddf_fun_t *fun, int *speed,
+static int rtl8139_set_addr(ddf_fun_t *fun, const nic_address_t *);
+static int rtl8139_get_device_info(ddf_fun_t *fun, nic_device_info_t *info);
+static int rtl8139_get_cable_state(ddf_fun_t *fun, nic_cable_state_t *state);
+static int rtl8139_get_operation_mode(ddf_fun_t *fun, int *speed,
     nic_channel_mode_t *duplex, nic_role_t *role);
-static errno_t rtl8139_set_operation_mode(ddf_fun_t *fun, int speed,
+static int rtl8139_set_operation_mode(ddf_fun_t *fun, int speed,
     nic_channel_mode_t duplex, nic_role_t);
 
-static errno_t rtl8139_pause_get(ddf_fun_t*, nic_result_t*, nic_result_t*, 
+static int rtl8139_pause_get(ddf_fun_t*, nic_result_t*, nic_result_t*, 
     uint16_t *);
-static errno_t rtl8139_pause_set(ddf_fun_t*, int, int, uint16_t);
-
-static errno_t rtl8139_autoneg_enable(ddf_fun_t *fun, uint32_t advertisement);
-static errno_t rtl8139_autoneg_disable(ddf_fun_t *fun);
-static errno_t rtl8139_autoneg_probe(ddf_fun_t *fun, uint32_t *our_advertisement,
+static int rtl8139_pause_set(ddf_fun_t*, int, int, uint16_t);
+
+static int rtl8139_autoneg_enable(ddf_fun_t *fun, uint32_t advertisement);
+static int rtl8139_autoneg_disable(ddf_fun_t *fun);
+static int rtl8139_autoneg_probe(ddf_fun_t *fun, uint32_t *our_advertisement,
     uint32_t *their_advertisement, nic_result_t *result, 
     nic_result_t *their_result);
-static errno_t rtl8139_autoneg_restart(ddf_fun_t *fun);
-
-static errno_t rtl8139_defective_get_mode(ddf_fun_t *fun, uint32_t *mode);
-static errno_t rtl8139_defective_set_mode(ddf_fun_t *fun, uint32_t mode);
-
-static errno_t rtl8139_wol_virtue_add(nic_t *nic_data,
+static int rtl8139_autoneg_restart(ddf_fun_t *fun);
+
+static int rtl8139_defective_get_mode(ddf_fun_t *fun, uint32_t *mode);
+static int rtl8139_defective_set_mode(ddf_fun_t *fun, uint32_t mode);
+
+static int rtl8139_wol_virtue_add(nic_t *nic_data,
 	const nic_wol_virtue_t *virtue);
 static void rtl8139_wol_virtue_rem(nic_t *nic_data,
 	const nic_wol_virtue_t *virtue);
 
-static errno_t rtl8139_poll_mode_change(nic_t *nic_data, nic_poll_mode_t mode,
+static int rtl8139_poll_mode_change(nic_t *nic_data, nic_poll_mode_t mode,
     const struct timeval *period);
 static void rtl8139_poll(nic_t *nic_data);
@@ -334,5 +334,5 @@
 static ddf_dev_ops_t rtl8139_dev_ops;
 
-static errno_t rtl8139_dev_add(ddf_dev_t *dev);
+static int rtl8139_dev_add(ddf_dev_t *dev);
 
 /** Basic driver operations for RTL8139 driver */
@@ -348,6 +348,6 @@
 
 /* The default implementation callbacks */
-static errno_t rtl8139_on_activated(nic_t *nic_data);
-static errno_t rtl8139_on_stopped(nic_t *nic_data);
+static int rtl8139_on_activated(nic_t *nic_data);
+static int rtl8139_on_stopped(nic_t *nic_data);
 static void rtl8139_send_frame(nic_t *nic_data, void *data, size_t size);
 
@@ -842,9 +842,8 @@
  *  @param nic_data  The driver data
  *
- *  @param[out] handle  IRQ capability handle if the handler was registered.
- *
- *  @return An error code otherwise.
- */
-inline static errno_t rtl8139_register_int_handler(nic_t *nic_data, cap_handle_t *handle)
+ *  @return IRQ capability handle if the handler was registered.
+ *  @return Negative error code otherwise.
+ */
+inline static int rtl8139_register_int_handler(nic_t *nic_data)
 {
 	rtl8139_t *rtl8139 = nic_get_specific(nic_data);
@@ -857,10 +856,10 @@
 	rtl8139_irq_code.cmds[2].addr = rtl8139->io_addr + ISR;
 	rtl8139_irq_code.cmds[3].addr = rtl8139->io_addr + IMR;
-	errno_t rc = register_interrupt_handler(nic_get_ddf_dev(nic_data),
-	    rtl8139->irq, rtl8139_interrupt_handler, &rtl8139_irq_code, handle);
+	int cap = register_interrupt_handler(nic_get_ddf_dev(nic_data),
+	    rtl8139->irq, rtl8139_interrupt_handler, &rtl8139_irq_code);
 
 	RTL8139_IRQ_STRUCT_UNLOCK();
 
-	return rc;
+	return cap;
 }
 
@@ -904,5 +903,5 @@
  *  @return EOK if activated successfully, error code otherwise
  */
-static errno_t rtl8139_on_activated(nic_t *nic_data)
+static int rtl8139_on_activated(nic_t *nic_data)
 {
 	assert(nic_data);
@@ -919,5 +918,5 @@
 	rtl8139_hw_int_set(rtl8139);
 
-	errno_t rc = hw_res_enable_interrupt(rtl8139->parent_sess, rtl8139->irq);
+	int rc = hw_res_enable_interrupt(rtl8139->parent_sess, rtl8139->irq);
 	if (rc != EOK) {
 		rtl8139_on_stopped(nic_data);
@@ -935,5 +934,5 @@
  *  @return EOK if succeed, error code otherwise
  */
-static errno_t rtl8139_on_stopped(nic_t *nic_data)
+static int rtl8139_on_stopped(nic_t *nic_data)
 {
 	assert(nic_data);
@@ -955,9 +954,9 @@
 
 
-static errno_t rtl8139_unicast_set(nic_t *nic_data, nic_unicast_mode_t mode,
+static int rtl8139_unicast_set(nic_t *nic_data, nic_unicast_mode_t mode,
     const nic_address_t *, size_t);
-static errno_t rtl8139_multicast_set(nic_t *nic_data, nic_multicast_mode_t mode,
+static int rtl8139_multicast_set(nic_t *nic_data, nic_multicast_mode_t mode,
     const nic_address_t *addr, size_t addr_count);
-static errno_t rtl8139_broadcast_set(nic_t *nic_data, nic_broadcast_mode_t mode);
+static int rtl8139_broadcast_set(nic_t *nic_data, nic_broadcast_mode_t mode);
 
 
@@ -1025,7 +1024,7 @@
  *  @param hw_resources  Devices hardware resources
  *
- *  @return EOK if succeed, error code otherwise
- */
-static errno_t rtl8139_fill_resource_info(ddf_dev_t *dev, const hw_res_list_parsed_t
+ *  @return EOK if succeed, negative error code otherwise
+ */
+static int rtl8139_fill_resource_info(ddf_dev_t *dev, const hw_res_list_parsed_t
     *hw_resources)
 {
@@ -1065,7 +1064,7 @@
  *  @param dev  The device structure
  *
- *  @return EOK if succeed, error code otherwise
- */
-static errno_t rtl8139_get_resource_info(ddf_dev_t *dev)
+ *  @return EOK if succeed, negative error code otherwise
+ */
+static int rtl8139_get_resource_info(ddf_dev_t *dev)
 {
 	assert(dev);
@@ -1078,10 +1077,10 @@
 
 	/* Get hw resources form parent driver */
-	errno_t rc = nic_get_resources(nic_data, &hw_res_parsed);
+	int rc = nic_get_resources(nic_data, &hw_res_parsed);
 	if (rc != EOK)
 		return rc;
 
 	/* Fill resources information to the device */
-	errno_t ret = rtl8139_fill_resource_info(dev, &hw_res_parsed);
+	int ret = rtl8139_fill_resource_info(dev, &hw_res_parsed);
 	hw_res_list_parsed_clean(&hw_res_parsed);
 
@@ -1098,8 +1097,8 @@
  * @return EOK in the case of success, error code otherwise
  */
-static errno_t rtl8139_buffers_create(rtl8139_t *rtl8139)
+static int rtl8139_buffers_create(rtl8139_t *rtl8139)
 {
 	size_t i = 0;
-	errno_t rc;
+	int rc;
 
 	ddf_msg(LVL_DEBUG, "Creating buffers");
@@ -1147,11 +1146,11 @@
  *  @param dev  The device information
  *
- *  @return EOK if succeed, error code otherwise
- */
-static errno_t rtl8139_device_initialize(ddf_dev_t *dev)
+ *  @return EOK if succeed, negative error code otherwise
+ */
+static int rtl8139_device_initialize(ddf_dev_t *dev)
 {
 	ddf_msg(LVL_DEBUG, "rtl8139_dev_initialize %s", ddf_dev_get_name(dev));
 
-	errno_t ret = EOK;
+	int ret = EOK;
 
 	ddf_msg(LVL_DEBUG, "rtl8139: creating device data");
@@ -1206,7 +1205,7 @@
  * @param dev  The RTL8139 device.
  *
- * @return EOK if successed, error code otherwise
- */
-static errno_t rtl8139_pio_enable(ddf_dev_t *dev)
+ * @return EOK if successed, negative error code otherwise
+ */
+static int rtl8139_pio_enable(ddf_dev_t *dev)
 {
 	ddf_msg(LVL_DEBUG, NAME ": rtl8139_pio_enable %s", ddf_dev_get_name(dev));
@@ -1256,7 +1255,7 @@
  * @param dev  The RTL8139 device.
  *
- * @return EOK if added successfully, error code otherwise
- */
-errno_t rtl8139_dev_add(ddf_dev_t *dev)
+ * @return EOK if added successfully, negative error code otherwise
+ */
+int rtl8139_dev_add(ddf_dev_t *dev)
 {
 	ddf_fun_t *fun;
@@ -1266,5 +1265,5 @@
 
 	/* Init device structure for rtl8139 */
-	errno_t rc = rtl8139_device_initialize(dev);
+	int rc = rtl8139_device_initialize(dev);
 	if (rc != EOK)
 		return rc;
@@ -1288,7 +1287,7 @@
 
 	/* Register interrupt handler */
-	int irq_cap;
-	rc = rtl8139_register_int_handler(nic_data, &irq_cap);
-	if (rc != EOK) {
+	int irq_cap = rtl8139_register_int_handler(nic_data);
+	if (irq_cap < 0) {
+		rc = irq_cap;
 		goto err_pio;
 	}
@@ -1339,7 +1338,7 @@
  *  @param max_len  Maximal addresss length to store
  *
- *  @return EOK if succeed, error code otherwise
- */
-static errno_t rtl8139_set_addr(ddf_fun_t *fun, const nic_address_t *addr)
+ *  @return EOK if succeed, negative error code otherwise
+ */
+static int rtl8139_set_addr(ddf_fun_t *fun, const nic_address_t *addr)
 {
 	assert(fun);
@@ -1352,5 +1351,5 @@
 	rtl8139_lock_all(rtl8139);
 
-	errno_t rc = nic_report_address(nic_data, addr);
+	int rc = nic_report_address(nic_data, addr);
 	if ( rc != EOK) {
 		rtl8139_unlock_all(rtl8139);
@@ -1371,5 +1370,5 @@
  *  @return EOK
  */
-static errno_t rtl8139_get_device_info(ddf_fun_t *fun, nic_device_info_t *info)
+static int rtl8139_get_device_info(ddf_fun_t *fun, nic_device_info_t *info)
 {
 	assert(fun);
@@ -1406,5 +1405,5 @@
  *  @return EOK
  */
-static errno_t rtl8139_get_cable_state(ddf_fun_t *fun, nic_cable_state_t *state)
+static int rtl8139_get_cable_state(ddf_fun_t *fun, nic_cable_state_t *state)
 {
 	assert(fun);
@@ -1425,5 +1424,5 @@
 /** Get operation mode of the device
  */
-static errno_t rtl8139_get_operation_mode(ddf_fun_t *fun, int *speed,
+static int rtl8139_get_operation_mode(ddf_fun_t *fun, int *speed,
     nic_channel_mode_t *duplex, nic_role_t *role)
 {
@@ -1502,5 +1501,5 @@
  *  @return EOK if succeed
  */
-static errno_t rtl8139_pause_get(ddf_fun_t *fun, nic_result_t *we_send, 
+static int rtl8139_pause_get(ddf_fun_t *fun, nic_result_t *we_send, 
     nic_result_t *we_receive, uint16_t *time)
 {
@@ -1537,5 +1536,5 @@
  *  @return EOK if succeed, INVAL if the pause frame has no sence
  */
-static errno_t rtl8139_pause_set(ddf_fun_t *fun, int allow_send, int allow_receive, 
+static int rtl8139_pause_set(ddf_fun_t *fun, int allow_send, int allow_receive, 
     uint16_t time)
 {
@@ -1567,5 +1566,5 @@
  *
  */
-static errno_t rtl8139_set_operation_mode(ddf_fun_t *fun, int speed,
+static int rtl8139_set_operation_mode(ddf_fun_t *fun, int speed,
     nic_channel_mode_t duplex, nic_role_t role)
 {
@@ -1611,5 +1610,5 @@
  *  @returns EOK if advertisement mode set successfully
  */
-static errno_t rtl8139_autoneg_enable(ddf_fun_t *fun, uint32_t advertisement)
+static int rtl8139_autoneg_enable(ddf_fun_t *fun, uint32_t advertisement)
 {
 	assert(fun);
@@ -1657,5 +1656,5 @@
  *  @returns EOK
  */
-static errno_t rtl8139_autoneg_disable(ddf_fun_t *fun)
+static int rtl8139_autoneg_disable(ddf_fun_t *fun)
 {
 	assert(fun);
@@ -1708,5 +1707,5 @@
  *  @returns EOK
  */
-static errno_t rtl8139_autoneg_probe(ddf_fun_t *fun, uint32_t *advertisement,
+static int rtl8139_autoneg_probe(ddf_fun_t *fun, uint32_t *advertisement,
     uint32_t *their_adv, nic_result_t *result, nic_result_t *their_result)
 {
@@ -1745,5 +1744,5 @@
  *  @returns EOK
  */
-static errno_t rtl8139_autoneg_restart(ddf_fun_t *fun)
+static int rtl8139_autoneg_restart(ddf_fun_t *fun)
 {
 	assert(fun);
@@ -1793,5 +1792,5 @@
  *  @returns EOK
  */
-static errno_t rtl8139_unicast_set(nic_t *nic_data, nic_unicast_mode_t mode,
+static int rtl8139_unicast_set(nic_t *nic_data, nic_unicast_mode_t mode,
     const nic_address_t *addr, size_t addr_cnt)
 {
@@ -1851,5 +1850,5 @@
  *  @returns EOK
  */
-static errno_t rtl8139_multicast_set(nic_t *nic_data, nic_multicast_mode_t mode,
+static int rtl8139_multicast_set(nic_t *nic_data, nic_multicast_mode_t mode,
     const nic_address_t *addr, size_t addr_count)
 {
@@ -1894,5 +1893,5 @@
  *  @returns EOK
  */
-static errno_t rtl8139_broadcast_set(nic_t *nic_data, nic_broadcast_mode_t mode)
+static int rtl8139_broadcast_set(nic_t *nic_data, nic_broadcast_mode_t mode)
 {
 	assert(nic_data);
@@ -1922,5 +1921,5 @@
  *  @param[out] mode    The current mode
  */
-static errno_t rtl8139_defective_get_mode(ddf_fun_t *fun, uint32_t *mode)
+static int rtl8139_defective_get_mode(ddf_fun_t *fun, uint32_t *mode)
 {
 	assert(fun);
@@ -1947,5 +1946,5 @@
  *  @returns EOK of mode was set
  */
-static errno_t rtl8139_defective_set_mode(ddf_fun_t *fun, uint32_t mode)
+static int rtl8139_defective_set_mode(ddf_fun_t *fun, uint32_t mode)
 {
 	assert(fun);
@@ -1979,5 +1978,5 @@
  *  @returns ELIMIT if no more methods of this kind can be enabled
  */
-static errno_t rtl8139_wol_virtue_add(nic_t *nic_data,
+static int rtl8139_wol_virtue_add(nic_t *nic_data,
 	const nic_wol_virtue_t *virtue)
 {
@@ -2058,9 +2057,9 @@
  *  @returns ENOTSUP if the mode is not supported
  */
-static errno_t rtl8139_poll_mode_change(nic_t *nic_data, nic_poll_mode_t mode,
+static int rtl8139_poll_mode_change(nic_t *nic_data, nic_poll_mode_t mode,
     const struct timeval *period)
 {
 	assert(nic_data);
-	errno_t rc = EOK;
+	int rc = EOK;
 
 	rtl8139_t *rtl8139 = nic_get_specific(nic_data);
@@ -2143,5 +2142,5 @@
 	printf("%s: HelenOS RTL8139 network adapter driver\n", NAME);
 
-	errno_t rc = nic_driver_init(NAME);
+	int rc = nic_driver_init(NAME);
 	if (rc != EOK)
 		return rc;
Index: uspace/drv/nic/rtl8139/general.c
===================================================================
--- uspace/drv/nic/rtl8139/general.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/nic/rtl8139/general.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -81,7 +81,7 @@
  *  @param time        The requested time
  *
- *  @return EOK if succeed, error code otherwise
+ *  @return EOK if succeed, negative error code otherwise
  */
-errno_t rtl8139_timer_act_init(rtl8139_timer_act_t * ta, uint32_t timer_freq,
+int rtl8139_timer_act_init(rtl8139_timer_act_t * ta, uint32_t timer_freq,
     const struct timeval *time) 
 {
Index: uspace/drv/nic/rtl8139/general.h
===================================================================
--- uspace/drv/nic/rtl8139/general.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/nic/rtl8139/general.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -61,5 +61,5 @@
 extern void *rtl8139_memcpy_wrapped(void *, const void *, size_t, size_t,
     size_t);
-extern errno_t rtl8139_timer_act_init(rtl8139_timer_act_t *, uint32_t,
+extern int rtl8139_timer_act_init(rtl8139_timer_act_t *, uint32_t,
     const struct timeval *);
 extern int rtl8139_timer_act_step(rtl8139_timer_act_t *, uint32_t *);
